;Computing and Networking Services - Security Analyzer Tool
;Written by Mike Wiseman, Evgueni Martynov

; This version includes Antivirus check
; the file can be renames into checker_nr.exe to read checker_cgf_nr.txt
; instead of checker_cfg.txt
; this file is identicav  SVN revision 280 the next revision 282 has
; AV check moved before everything else but this is not configurable via
; remote ESP server using /cgi-bin/getconfig.cgi



;---------------------
;Include Modern UI and library for ConfigRead and ConfigWrite functions.

  !include "MUI.nsh"
  !include "TextFunc.nsh"


;--------------------------------
;General

  ;Name and file
  Name "Endpoint Security Health Tool"
  Caption "Endpoint Security Health Tool"
  OutFile "checker201.exe"
  ;ShowInstDetails show
  
;--------------------------------
;Pages

 ;!insertmacro MUI_PAGE_LICENSE "${NSISDIR}\Contrib\Modern UI\License.txt"
  !define MUI_HEADERIMAGE
  !define MUI_HEADERIMAGE_BITMAP ".\uoft_logo.bmp"
  !define MUI_HEADERIMAGE_RIGHT
  !define MUI_HEADERIMAGE_BITMAP_NOSTRETCH
  Page custom CustomPageA
  Page custom CustomPageB
  !define MUI_PAGE_HEADER_TEXT "Host Scan page v2"
  !define MUI_PAGE_HEADER_SUBTEXT "Please wait while your computer is checked for installed patches."
  !define MUI_INSTFILESPAGE_FINISHHEADER_TEXT "Scan Complete"
  !define MUI_INSTFILESPAGE_FINISHHEADER_SUBTEXT "Click the 'Next' Button to view results."
  !insertmacro MUI_PAGE_INSTFILES
  Page custom CustomPageC
  
;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"
  !insertmacro ConfigRead
  !insertmacro ConfigWrite

;--------------------------------
;Reserve Files
  
  ;These files should be inserted before other files in the data block
  ;Keep these lines before any File command
  ;Only for solid compression (by default, solid compression is enabled for BZIP2 and LZMA)
  
  ReserveFile "ioA.ini"
  ;ReserveFile "ioB.ini"
  ReserveFile "ioC.ini"
  !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS




;--------------------------------
;Variables

  Var AV_CHECK_ENABLE
  Var CHECKER_STATUS
  Var DOWNLOAD_FILENAME
  Var DOWNLOAD_URL
  Var DOWNLOAD_URL_FLAG
  Var ESP_LOCAL_CFG_FILENAME
  Var EXTERNAL_URL
  Var FAIL_DETAIL_STR
  Var FILE_HANDLE
  Var FILE_OUTPUT
  Var IE_PATH
  Var NETREG_COOKIE_EXPIRE
  Var NETREG_DFP
  Var NETREG_SERVER_DATE
  Var NETREG_SERVER_TIME
  Var NETREG_URL
  Var NETREG_URL_SSL
  Var PWD_CHECK_ENABLE
  Var SP_VERSION
  Var TEMP_FILENAME_STR
  Var TEMP_FILENAME2_STR
  Var TEMP_VAR
  Var WIN_VERSION
  Var EICAR_AV_CHECK
  Var AV_DETAIL  
  Var EICAR_AV_DETAIL
  Var AV_UPTODATE
  Var AV_INFO 
  Var AV_SERVICE
  Var INSTALLER_NAME
  Var CHECKER_CFG
  Var EICAR_FILE
  Var AV_CHECK_LOG_ENABLE
  Var AV_SLEEP_DELAY
  var CHECKER_VERSION
  Var REMOTE_VERSION
  Var VER_FILENAME
  Var AV_UPTODATE_CHECK
  Var EICAR_CHECK
  Var EICAR_CHECK_ONLY
  Var AVNOTUPTODATE_FILENAME
  Var FW_INFO
  Var MBSAv2PatchList
  Var MBSAv2PatchStatus
  Var MBSAv2BID
  Var MBSAv2data
  Var MBSAv2PatchFile
  Var WSUSSCAN
  Var ElemCode
  Var FAILPAGE
  Var NEXTPAGE
  Var WSCATALOG
  Var VISTA_FLAG
  Var LiveOneCare
  Var GlobalAVInfo
  Var GlobalAVUptodateStatus
  Var CurrAVName
  Var CurrAVVersion
  Var CurrAVStatus
  Var LogCurrAVName
  Var LogCurrAVVersion
  Var LogCurrAVStatus
  Var NumAV
  Var AVInfoPopUpMsg
  Var DHCPServerIP
  Var IPAddress
  Var MACAddress
  Var NetRegIP
  Var ROUTER_CHECK
  Var ROUTER_CHECK_ACTION
  Var ROUTER_CHECK_MESSAGE
  Var AllAVuptodate


;--------------------------------
;Installer Sections

Section "Dummy Section" SecDummy

  ; ***********************************************************************************
  ; Variable Initialization and Default Setup
  ;
  StrCpy $AV_CHECK_ENABLE "disabled"
  StrCpy $PWD_CHECK_ENABLE "disabled"
  StrCpy $TEMP_FILENAME2_STR "temp_file2"
  
  StrCpy $EICAR_FILE "$TEMP\EICAR.com"  

  ; ***********************************************************************************
  ; check for non-admin user and unsupported OS type.
  ;
  UserInfo::GetName
  IfErrors Win9x
  Pop $0
  UserInfo::GetAccountType
  Pop $1
  StrCmp $1 "Admin" 0 +2
  Goto fin
  MessageBox MB_OK 'User "$0" is NOT in the Administrators group - you must login as a user with Administrative rights.'
  Quit

  Win9x:
  # This one means you don't need to care about admin or
  # not admin because Windows 9x doesn't either
  MessageBox MB_OK "Error! This utility cannot run under Windows 95, 98 or ME - exiting."
  Quit

  fin:

  ; ************************************************************************************
  ; get IE version and start doing general setup.
  ;
  Call GetIEVersion
  Pop $R0
  DetailPrint ""
  DetailPrint "       IE version: $R0"
  DetailPrint ""

  ; get IE path
  StrCpy $IE_PATH "$PROGRAMFILES\Internet Explorer\IEXPLORE.EXE" 

  ; get the Windows temp directory
  ;
  SetOutPath "$TEMP"
  
  GetTempFileName $TEMP_FILENAME_STR
 
  ;User Custom Variable 
  ;  
  ; Enter a URL where ESP utilities and policy files are stored (optional).
  ; The files allowed here are:
  ; *.txt (the update policy files) and mssecure.cab. This feature allows
  ; the ESP admin to centrally manage these in one spot. Note that all of these files are
  ; also required to be included with the single wizard file just in case network
  ; connectivity to the central site is lost. Example:
  ; StrCpy $DOWNLOAD_URL "http://my-main-server.edu/dir-of-policy-files/"
  ; If this feature is not desired, use:
  ; StrCpy $DOWNLOAD_URL ""

  File "fwcheck.wsf"
  File "avcheck.wsf"
  File "ESP_update_policy.txt"
  File "checker_cfg.txt"
  File "checker_cfg_nr.txt"
  File "setdate.exe"
  File "wget.exe"
  File "libiconv2.dll"
  File "libintl3.dll"
  File "ssleay32.dll"
  File "libeay32.dll"
  File "av.bat"
  File "listservices.js"
  File "mbsacli.exe"
  File "wusscan.dll"
  File "mbsa.bat"
  File "espscript.bat"
  File "dhcpinfo.wsf"
  File "dhcpinfo.bat"
  File "cookies.exe"
 
  ; ************************************************************************
  ; read in and echo central configuration values.
  ;
  DetailPrint ""
  DetailPrint "       Central cfg settings:"
  
  ; CHECKER_STATUS [true] - indicates checker is in NetReg integration mode.
 


; This call sets the config file based on installer name
; if installer has "_" in its name it will run in the ESP mode reading checker_cfg_nr.txt
; otherwise it'll use checker_cfg.txt

Call ChooseCfg

;;;;;;;;;;;comment this;;;;;;;;;;;;
;Call AntiVirusInfo
;Call Cleanup
;Quit

;;;;;;;;;;;;;;;;;;;;;;;

 
 ${ConfigRead} $CHECKER_CFG "netreg_integration=" $R0
  StrCpy $CHECKER_STATUS $R0
  StrCmp $CHECKER_STATUS "true" +2 +1
  StrCpy $CHECKER_STATUS "false"
  DetailPrint "       netreg_integration=$CHECKER_STATUS"

  ; DOWNLOAD_URL - URL pointing to central policy file location.
  ${ConfigRead} $CHECKER_CFG "policy_file_site=" $R0
  StrCpy $DOWNLOAD_URL_FLAG "true"
  StrCpy $DOWNLOAD_URL $R0
  StrCmp $DOWNLOAD_URL "" +1 +2
  StrCpy $DOWNLOAD_URL_FLAG "false"
  DetailPrint "       policy_file_site=$DOWNLOAD_URL"

  ; EXTERNAL_URL - URL pointing to external valid website - used to trigger HTTP response from ESP server.
  ${ConfigRead} $CHECKER_CFG "external_url=" $R0
  StrCpy $EXTERNAL_URL $R0
  StrCmp $EXTERNAL_URL "" +1 +2
  StrCpy $EXTERNAL_URL "http://www.google.com"
  DetailPrint "       external_url=$EXTERNAL_URL"
  
  DetailPrint ""


; This part of the program checks if REMOTE_VERSION from the central site match
; the local checker version stored in the checker_cfg_nr.txt file

 ${ConfigRead} $CHECKER_CFG "version=" $CHECKER_VERSION

 DetailPrint "local version: $CHECKER_VERSION"
 DetailPrint ""

  StrCpy $VER_FILENAME "ESPversion.txt"
  StrCmp $DOWNLOAD_URL_FLAG "true" +1 ver
# NSISdl::download_quiet $DOWNLOAD_URL$DOWNLOAD_FILENAME $TEMP\$DOWNLOAD_FILENAME
#  Pop $R0 ;Get the return value
#  StrCmp $R0 "success" +1 ver

nsExec::ExecToLog '"wget.exe" -q -T 10 -t 1 -O "$TEMP\$VER_FILENAME" "$DOWNLOAD_URLversion.txt"'
ifFileExists $TEMP\$VER_FILENAME +1 ver

${ConfigRead} "$TEMP\$VER_FILENAME" "version=" $REMOTE_VERSION
	

ver:
  DetailPrint "Download of remote $VER_FILENAME: $R0 (version=$REMOTE_VERSION)"
  DetailPrint ""

StrCmp $CHECKER_STATUS "true" +1 vercontinue
StrCmp $CHECKER_VERSION $REMOTE_VERSION vercontinue +1


MessageBox MB_OK "You got this message because of the one of the following:$\n$\n- you ran an older version $CHECKER_VERSION of ESP Client Software from your hard drive$\n- third party firewall is blocking access to ESP resources$\n- multiple Antiviruses and/or their components are in conflict with each other$\n$\nYou could seek help or try these things:$\n$\n- run the current version $REMOTE_VERSION of ESP$\n- temporarily turn off third party firewall$\n- uninstall all Antiviruses with their components and install Symantec AV"

;MessageBox MB_OK "This is the OLD version $CHECKER_VERSION of the ESP Client Software!$\nPlease make sure that you run the newest version $REMOTE_VERSION.$\nTo get the newest version simply go to any external web site, like www.google.com$\nand you will be redirected to the page with the link to the new ESP software."
    Call Cleanup
    Quit


vercontinue:


  ; ************************************************************************
  ;
  ; START OF MBSA version 2 WRAPPER CODE
  ;
  ; ************************************************************************
  ;

  Push $TEMP_FILENAME_STR
Call MBSAv2XML


  ; Test version of mbsa - running this will cause the test to show a missing MS04-016 patch.
  ;nsExec::ExecToLog '"mbsacli.exe" /hf /f $TEMP_FILENAME_STR -b -z -nvc -x "mssecure.cab"'
  Pop $0 # return value/error/timeout
  DetailPrint ""
  DetailPrint "       mbsacli exec status: $0"
  DetailPrint ""

  Call GetWindowsVersion
  Pop $WIN_VERSION


  ; For no installed SP, change function response to blank string
  Call GetServicePack
  Pop $SP_VERSION

  ; Append SP version to Win version.
  StrCpy $WIN_VERSION "$WIN_VERSION $SP_VERSION"
  DetailPrint "       Detected OS/SP: $WIN_VERSION"
  DetailPrint " "

;MessageBox MB_OK "OS version: $WIN_VERSION"

; Right now we allow Vista with any Service Pack
  StrCpy $R0 $WIN_VERSION 5
  StrCmp $R0 "Vista" ESP_Policy +1

  StrCmp $WIN_VERSION "XP 2" ESP_Policy +1
  StrCmp $WIN_VERSION "2000 4" ESP_Policy +1
  StrCmp $WIN_VERSION "2003 " ESP_Policy +1
  StrCmp $WIN_VERSION "2003 1" ESP_Policy +1
  StrCmp $WIN_VERSION "2003 2" ESP_Policy +1

  StrCpy $FAIL_DETAIL_STR "Not supported OS-SP [$WIN_VERSION] - We support 2000-SP4,XP-SP2,2003,Vista. Please run Microsoft Update to see if an update is suggested."
  Goto done



  ESP_Policy:
  StrCpy $DOWNLOAD_FILENAME "ESP_update_policy.txt"
  Rename $TEMP\$DOWNLOAD_FILENAME $TEMP\$TEMP_FILENAME2_STR
  StrCmp $DOWNLOAD_URL_FLAG "true" +1 +4
  NSISdl::download_quiet $DOWNLOAD_URL$DOWNLOAD_FILENAME $TEMP\$DOWNLOAD_FILENAME
  Pop $R0 ;Get the return value
  StrCmp $R0 "success" +1 download_fail
  FileOpen $FILE_HANDLE $DOWNLOAD_FILENAME "r"
  Goto loop





  ; Must look for IE path in NT - not the same as XP or 2000
  ReadRegStr $IE_PATH HKCR "Applications\iexplore.exe\shell\open\command" ""
  DetailPrint " Detected IE path: $IE_PATH"


  download_fail:
    DetailPrint "       Download of $DOWNLOAD_FILENAME failed - using local copy."
    Rename $TEMP\$TEMP_FILENAME2_STR $TEMP\$DOWNLOAD_FILENAME
    FileOpen $FILE_HANDLE $DOWNLOAD_FILENAME "r"
    Goto loop

  loop:
    ClearErrors

    ; read a line which contains a required patch string
    FileRead $FILE_HANDLE $FILE_OUTPUT
    IfErrors done

    ; trim the EOL characters
    Push $FILE_OUTPUT
    Call TrimNewlines
    Pop $FILE_OUTPUT

    ; skip comment lines
    StrCpy $0 $FILE_OUTPUT 1 0
    StrCmp $0 "#" +1 +2
      Goto loop

    ; look for required patch in mbsacli output
    ; if it's not there, move on; if it is, append it
    ; to FAIL_DETAIL_STR
    DetailPrint "       Checking for $FILE_OUTPUT."
    Push $TEMP_FILENAME_STR 
    Push $FILE_OUTPUT
    Call FileSearch
    Pop $0
    Pop $1
    Pop $2
    StrCmp $0 "0" +2 +1
    StrCpy $FAIL_DETAIL_STR "$FAIL_DETAIL_STR\r\n$FILE_OUTPUT"
    Goto loop
  done:

  DetailPrint " "       
  FileClose $FILE_HANDLE

  ; ***************************************************************************************
  ;
  ; END OF MBSA WRAPPER CODE
  ; 
  ; ***************************************************************************************

  ; check for netreg integration mode
  StrCmp $CHECKER_STATUS "false" standalone netreg

  standalone:
    ; if FAIL_DETAIL_STR is empty, all patches are installed; if not, print the output.
    StrCmp $FAIL_DETAIL_STR "" +1 +2
    StrCpy $FAIL_DETAIL_STR "No missing patches.\r\n"
    
    Call DHCPinfo
    Call FWCheck
    Call AntiVirusInfo

;  open pop-up window if number of AV > 2
    IntCmp $NumAV 1 +2 +2 +1
    MessageBox MB_OK $AVInfoPopUpMsg

    DetailPrint ""
    StrCmp $AV_DETAILE "missing" +1 +1
    StrCpy $FAIL_DETAIL_STR "$FAIL_DETAIL_STR\r\nWindows Security Center Antivirus info - AV is $AV_DETAIL"


    StrCmp $AV_UPTODATE "" +2 +1
    StrCpy $FAIL_DETAIL_STR "$FAIL_DETAIL_STR\r\nAV $AV_UPTODATE"
    StrCpy $FAIL_DETAIL_STR "$FAIL_DETAIL_STR\r\nAV EICAR test - $EICAR_AV_DETAIL"
    StrCpy $FAIL_DETAIL_STR "$FAIL_DETAIL_STR\r\nAV process - $AV_SERVICE"
    
    StrCpy $FAIL_DETAIL_STR "$FAIL_DETAIL_STR\r\nFirewall info - $FW_INFO"
    StrCpy $FAIL_DETAIL_STR "$FAIL_DETAIL_STR\r\n$MBSAv2PatchList"

    DetailPrint $FAIL_DETAIL_STR 

;    StrCmp $R0 "missing"  +1 +2
;    StrCpy $FAIL_DETAIL_STR "$FAIL_DETAIL_STR\r\n$AV_DETAIL"
 

      
   !insertmacro MUI_INSTALLOPTIONS_WRITE "ioC.ini" "Field 1" "State" "$FAIL_DETAIL_STR"

    Call Cleanup
    Goto finish

  netreg:


 Call DHCPinfo

    ; if FAIL_DETAIL_STR is empty, all patches are installed; if not, print the output.
    ; getting NetReg ip
    ;
    StrCpy $NETREG_DFP "netreg_default_page.html"
    ; NSISdl::download_quiet http://www.google.com $NETREG_DFP
    nsExec::ExecToLog '"wget.exe" -q -T 5 -t 1 -O "$NETREG_DFP" "$EXTERNAL_URL"'
    ;Pop $R0 ;Get the return value
    ;StrCmp $R0 "success" +2
    ;MessageBox MB_OK "Download failed: $R0"

    ; The NetReg box ip is on 2nd line
    FileOpen $FILE_HANDLE "netreg_default_page.html" "r"
    FileRead $FILE_HANDLE $1 

    ;reading netreg box ip
    FileRead $FILE_HANDLE $1
    
    Push $1
    Call TrimNewlines
    Pop $1
    
    StrCpy $NetRegIP $1
    StrCpy $NETREG_URL "http://$1"
    StrCpy $NETREG_URL_SSL "https://$1"
    DetailPrint "--- NetReg host ip: $NETREG_URL"

    ; reading cookie expire time generated by netreg box
    FileRead $FILE_HANDLE $1 
    Push $1
    Call TrimNewlines
    Pop $1
    StrCpy $NETREG_COOKIE_EXPIRE "$1"
    DetailPrint "--- NetReg cookie expire time: $NETREG_COOKIE_EXPIRE"

    ; reading server date
    FileRead $FILE_HANDLE $1 
    Push $1
    Call TrimNewlines
    Pop $1
    StrCpy $NETREG_SERVER_DATE "$1"
    DetailPrint "--- NetReg date: $NETREG_SERVER_DATE"

    ; reading server time
    FileRead $FILE_HANDLE $1 
    Push $1
    Call TrimNewlines
    Pop $1
    StrCpy $NETREG_SERVER_TIME "$1"
    DetailPrint "--- NetReg time: $NETREG_SERVER_TIME"
    FileClose $FILE_HANDLE


    ; ************************************************************************
    ; read in and echo local ESP server configuration values (if existing).
    ;

    ; set defaults
    StrCpy $ESP_LOCAL_CFG_FILENAME "esp.cfg"

    nsExec::ExecToLog '"wget.exe" -q -T 5 -t 1 -O "$TEMP\$ESP_LOCAL_CFG_FILENAME" "$NETREG_URL/cgi-bin/getconfig.cgi"'
    ifFileExists $TEMP\$ESP_LOCAL_CFG_FILENAME +1 check_patch_string

    DetailPrint ""
    DetailPrint "       Local ESP server cfg settings:"

    ; ANTIVIRUS CHECK STATUS [enabled|disabled] - enables antivirus detection.

    ${ConfigRead} "$TEMP\$ESP_LOCAL_CFG_FILENAME" "avcheck=" $R0
    StrCpy $AV_CHECK_ENABLE $R0
    StrCmp $AV_CHECK_ENABLE "disabled" +2 +1
    StrCpy $AV_CHECK_ENABLE "enabled"
    DetailPrint "       avcheck=$AV_CHECK_ENABLE"

    ${ConfigRead} "$TEMP\$ESP_LOCAL_CFG_FILENAME" "avchecklog=" $R0
    StrCpy $AV_CHECK_LOG_ENABLE $R0
    StrCmp $AV_CHECK_LOG_ENABLE "disabled" +2 +1
    StrCpy $AV_CHECK_LOG_ENABLE "enabled"
    DetailPrint "       avchecklog=$AV_CHECK_LOG_ENABLE"

      ${ConfigRead} "$TEMP\$ESP_LOCAL_CFG_FILENAME" "avuptodatecheck=" $R0
    StrCpy $AV_UPTODATE_CHECK $R0
    StrCmp $AV_UPTODATE_CHECK "disabled" +2 +1
    StrCpy $AV_UPTODATE_CHECK "enabled"
    DetailPrint "       avuptodatecheck=$AV_UPTODATE_CHECK"

    ${ConfigRead} "$TEMP\$ESP_LOCAL_CFG_FILENAME" "eicarcheck=" $R0
    StrCpy $EICAR_CHECK $R0
    StrCmp $EICAR_CHECK "disabled" +2 +1
    StrCpy $EICAR_CHECK "enabled"
    DetailPrint "       eicarcheck=$EICAR_CHECK"

    ${ConfigRead} "$TEMP\$ESP_LOCAL_CFG_FILENAME" "eicarcheckonly=" $R0
    StrCpy $EICAR_CHECK_ONLY $R0
    StrCmp $EICAR_CHECK_ONLY "enabled" +2 +1
    StrCpy $EICAR_CHECK_ONLY "disabled"
    DetailPrint "       eicarcheckonly=$EICAR_CHECK_ONLY"

   ${ConfigRead} "$TEMP\$ESP_LOCAL_CFG_FILENAME" "failpage=" $R0
    StrCpy $FAILPAGE $R0
    StrCmp $FAILPAGE "" +1 +2
    StrCpy $FAILPAGE "fail.htm"
    DetailPrint "       failpage=$FAILPAGE" 

   ${ConfigRead} "$TEMP\$ESP_LOCAL_CFG_FILENAME" "nextpage=" $R0
    StrCpy $NEXTPAGE $R0
    StrCmp $NEXTPAGE "" +1 +2
    StrCpy $NEXTPAGE "/cgi-bin/next.cgi"
    DetailPrint "       nextpage=$NEXTPAGE" 

; checking if user is behind a router 
; this is intended to prevent a case when one machine registeres
; a router MAC and all other comming without checking

    ${ConfigRead} "$TEMP\$ESP_LOCAL_CFG_FILENAME" "routercheck=" $R0
    StrCpy $ROUTER_CHECK $R0
    StrCmp $ROUTER_CHECK "enabled" +2 +1
    StrCpy $ROUTER_CHECK "disabled"
    DetailPrint "       routercheck=$ROUTER_CHECK"

    StrCmp $ROUTER_CHECK "enabled" +1 skip_routercheck	

; if host's DHCP server IP is different from thom the ESP server IP
; that means it get's its IP from a router (it's behind a router)
 
    StrCmp $NetRegIP $DHCPServerIP skip_routercheck +1


     
; routercheckaction=[pass|warn|block]

    ${ConfigRead} "$TEMP\$ESP_LOCAL_CFG_FILENAME" "routercheckaction=" $R0
    StrCpy $ROUTER_CHECK_ACTION $R0
    DetailPrint "       routercheckaction=$ROUTER_CHECK_ACTION"

; reporting Router Check status to the ESP server
nsExec::ExecToLog '"wget.exe" -q -T 5 -t 1 -O "$TEMP\routercheck.wget" "$NETREG_URL/cgi-bin/routercheck.cgi?netregip=$NetRegIP&routercheckaction=$ROUTER_CHECK_ACTION&ipaddress=$IPAddress&macaddress=$MACAddress&dhcpserverip=$DHCPServerIP"'

    StrCmp $ROUTER_CHECK_ACTION "pass" skip_routercheck +1

    ${ConfigRead} "$TEMP\$ESP_LOCAL_CFG_FILENAME" "routercheckmessage=" $R0
    StrCpy $ROUTER_CHECK_MESSAGE $R0
    DetailPrint "       routercheckmessage=$ROUTER_CHECK_MESSAGE"
    MessageBox MB_OK "Router check: $ROUTER_CHECK_MESSAGE"

StrCmp $ROUTER_CHECK_ACTION "block" +1 skip_routercheck
    Call Cleanup
    Quit       

skip_routercheck:

   ; commented out Nov 02/05 
   ; ; PASSWORD CHECK STATUS [enabled|disabled] - enables password audit.
   ; ${ConfigRead} "$TEMP\$ESP_LOCAL_CFG_FILENAME" "pwdcheck=" $R0
   ; StrCpy $PWD_CHECK_ENABLE $R0
   ; StrCmp $PWD_CHECK_ENABLE "enabled" +2 +1
   ; StrCpy $PWD_CHECK_ENABLE "disabled"
   ; DetailPrint "       pwdcheck=$PWD_CHECK_ENABLE"

    DetailPrint ""

    ; *************************************************************************
    ; 

    check_patch_string:

    ; write the correct time.
    nsExec::ExecToLog '"setdate.exe" $NETREG_SERVER_DATE $NETREG_SERVER_TIME'

    ; check for failed patch test, if true, write cookie, call page and exit.
    StrCmp "" $FAIL_DETAIL_STR avcheck +1
    System::Call "wininet::InternetSetCookie(t,t,t) (t'$NETREG_URL', t'', t'scanpassed=no; expires = $NETREG_COOKIE_EXPIRE')"
    System::Call "wininet::InternetSetCookie(t,t,t) (t'$NETREG_URL_SSL', t'', t'scanpassed=no; expires = $NETREG_COOKIE_EXPIRE')"
    Exec '"$IE_PATH" -new "$NETREG_URL/$FAILPAGE"'
    !insertmacro MUI_INSTALLOPTIONS_WRITE "ioC.ini" "Field 1" "State" "$FAIL_DETAIL_STR"
    Call Cleanup
    Quit


    ; check for failed av test, if true, write cookie, call page and exit.
    avcheck:
    StrCmp $AV_CHECK_ENABLE "enabled" +1 write_pass_cookies
    


;  moved dhcp check up to work pass/warn/block on it
;   Call DHCPinfo
    Call FWCheck
    Call AntiVirusInfo

;  open pop-up window if number of AV > 2
    IntCmp $NumAV 1 +3 +3 +1
    StrCmp $AllAVuptodate "no" +1 +2
    MessageBox MB_OK "Warning: Computer reports that at least one AntiVirus is not up-to-date$\n$AVInfoPopUpMsg"


;StrCmp $AV_SERVICE "" +2 +1
;StrCpy $AV_INFO "$AV_INFO&AV_SERVICE=$AV_SERVICE"

StrCmp $AV_CHECK_LOG_ENABLE "enabled" +1 noavlogging
; reporting AV status to the ESP server
    nsExec::ExecToLog '"wget.exe" -q -T 5 -t 1 -O "$TEMP\avinfo.wget" "$NETREG_URL/cgi-bin/before.cgi?$AV_INFO"'

; logging AV ingo via web logging by doing a request
StrCmp $DOWNLOAD_URL "" noavlogging +1
    nsExec::ExecToLog '"wget.exe" -q -T 5 -t 1 -O "$TEMP\avinfo.wget" "$DOWNLOAD_URL/log.php?$AV_INFO"'


noavlogging:

StrCmp $AV_UPTODATE_CHECK "disabled" avlabel1 +1
StrCmp $GlobalAVUptodateStatus "uptodate" avlabel1 +1
StrCmp $GlobalAVUptodateStatus "missing" +1 +2
StrCmp $EICAR_AV_DETAIL "pass" write_pass_cookies +1


; login below is  where to get the avfail.php page
; if it present on the local ESP server then from local
; otherwise get it from central location

Delete "$TEMP\avfail.php"
StrCpy $AVNOTUPTODATE_FILENAME "avfail.php"

nsExec::ExecToLog '"wget.exe" -q -T 10 -t 1 -P $TEMP "$NETREG_URL/$AVNOTUPTODATE_FILENAME"'

ifFileExists $TEMP\$AVNOTUPTODATE_FILENAME +1 avfailphpgetfromcental


Exec '"$IE_PATH" -new "$NETREG_URL/avfail.php?status=AntiVirus%20is%20$GlobalAVUptodateStatus"'
    Call Cleanup
    Quit


avfailphpgetfromcental:
Exec '"$IE_PATH" -new "$DOWNLOAD_URLavfail.php?status=AntiVirus%20is%20$GlobalAVUptodateStatus"'
    Call Cleanup
    Quit

;;;



avlabel1:

;StrCmp $EICAR_CHECK "disabled" +2 +1
;StrCmp $EICAR_AV_DETAIL "pass" write_pass_cookies +1
;StrCmp $EICAR_CHECK_ONLY "disabled" +1 +2
;StrCmp $AV_SERVICE "" +1 write_pass_cookies 

StrCmp $EICAR_CHECK "disabled" write_pass_cookies +1
StrCmp $EICAR_AV_DETAIL "pass" write_pass_cookies +1


avnotuptodate:

Delete "$TEMP\avfail.php"
StrCpy $AVNOTUPTODATE_FILENAME "avfail.php"

nsExec::ExecToLog '"wget.exe" -q -T 10 -t 1 -P $TEMP "$NETREG_URL/$AVNOTUPTODATE_FILENAME"'

ifFileExists $TEMP\$AVNOTUPTODATE_FILENAME +1 getcentralavfailphp

Exec '"$IE_PATH" -new "$NETREG_URL/avfail.php?status=AntiVirus%20EICAR%20test%20failed"'

!insertmacro MUI_INSTALLOPTIONS_WRITE "ioC.ini" "Field 1" "State" "$FAIL_DETAIL_STR"
    Call Cleanup
    Quit

; or if avfail.php is not present on local ESP server display
; centrally manages avfail.php

getcentralavfailphp:

Exec '"$IE_PATH" -new "$DOWNLOAD_URLavfail.php?status=AntiVirus%20EICAR%20test%20failed"'
 
!insertmacro MUI_INSTALLOPTIONS_WRITE "ioC.ini" "Field 1" "State" "$FAIL_DETAIL_STR"
    Call Cleanup
    Quit



   

    write_pass_cookies:

; commenting this thing below cause it doesn't allow us to set two cookies
;    System::Call "wininet::InternetSetCookie(t,t,t) (t'$NETREG_URL',t'', t'scanpassed=true; expires = $NETREG_COOKIE_EXPIRE')"


nsExec::ExecToLog  '"$TEMP\cookies.exe" "$NETREG_URL" "scanpassed = true; expires = $NETREG_COOKIE_EXPIRE"'

nsExec::ExecToLog  '"$TEMP\cookies.exe" "$NETREG_URL" "dhcpserverip = $DHCPServerIP; expires = $NETREG_COOKIE_EXPIRE"'


    Exec '"$IE_PATH" -new "$NETREG_URL/$NEXTPAGE"'
    Call Cleanup
    Quit
    

finish:

SectionEnd

;--------------------------------
;Installer Functions

Function .onInit

  ;Extract InstallOptions INI files
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "ioA.ini"
  ;!insertmacro MUI_INSTALLOPTIONS_EXTRACT "ioB.ini"
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "ioC.ini"
  
FunctionEnd

LangString TEXT_IO_TITLE ${LANG_ENGLISH} "InstallOptions page"
LangString TEXT_IO_SUBTITLE ${LANG_ENGLISH} "This is a page created using the InstallOptions plug-in."

Function CustomPageA

  !insertmacro MUI_HEADER_TEXT "ENDPOINT SECURITY HEALTH TOOL" "Computing and Networking Services, University of Toronto"
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY "ioA.ini"
  
FunctionEnd

Function CustomPageB
;
;  !insertmacro MUI_HEADER_TEXT "ENDPOINT SECURITY HEALTH TOOL" "Computing and Networking Services, University of Toronto"
;  !insertmacro MUI_INSTALLOPTIONS_DISPLAY "ioB.ini"
;  
FunctionEnd

Function CustomPageC

  !insertmacro MUI_HEADER_TEXT "Scan Results page" "See scan results below."
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY "ioC.ini"

FunctionEnd

Function Cleanup

  Delete "$TEMP\mbsacli.exe"
  Delete "$TEMP\ESP_update_policy.txt"
  Delete "$TEMP\mssecure.cab"
  Delete "$TEMP\mssecure.xml"
  Delete "$TEMP_FILENAME_STR"
  Delete "$TEMP\$TEMP_FILENAME2_STR"
  Delete "$TEMP\checker_cfg.txt"
  Delete "$TEMP\checker_cfg_nr.txt"
  Delete "$TEMP\setdate.exe"
  Delete "$TEMP\wget.exe"
  Delete "$TEMP\libiconv2.dll"
  Delete "$TEMP\libintl3.dll"
  Delete "$TEMP\ssleay32.dll"
  Delete "$TEMP\libeay32.dll" 
  Delete "$TEMP\$ESP_LOCAL_CFG_FILENAME"
  Delete "$TEMP\avcheck.wsf"
  Delete "$TEMP\avcheck.txt"
  Delete "$TEMP\avcheck.tmp"
  Delete "$TEMP\av.bat"
  Delete "$TEMP\avinfo.wget"
  Delete "$TEMP\netreg_default_page.html"
  Delete "$TEMP\listservices.js"
  Delete "$TEMP\avservice.txt"
  Delete $EICAR_FILE
  Delete "$TEMP\$VER_FILENAME"
  Delete "$TEMP\avnotuptodate.htm" 
  Delete "$TEMP\fwcheck.wsf"
  Delete "$TEMP\fwcheck.txt"
  Delete "$TEMP\mbsacli.exe"
  Delete "$TEMP\patches.xml"
  Delete "$TEMP\wsusscn2.cab"
  Delete "$TEMP\wusscan.dll"
  Delete "$TEMP\mbsa.bat"
  Delete "$TEMP\espscript.bat"
  Delete "$TEMP\WindowsUpdateAgent20-x86.exe"
  Delete "$TEMP\dhcpinfo.wsf"
  Delete "$TEMP\dhcpinfo.bat"
  Delete "$TEMP\dhcpinfo.txt"
  Delete "$TEMP\cookies.exe"
  Delete "$TEMP\routercheck.wget"
  Delete "$TEMP\avfail.php"

FunctionEnd



Function DHCPinfo

StrCpy $DHCPServerIP ""

DetailPrint ""
DetailPrint ""
DetailPrint "                                                      DHCP Info"



nsExec::ExecToLog  '"$TEMP\espscript.bat" "$TEMP\dhcpinfo.wsf" "$TEMP\dhcpinfo.txt"'


ifFileExists $TEMP\dhcpinfo.txt +1 notdhcp
${ConfigRead} "$TEMP\dhcpinfo.txt" "IPAddress=" $R0
DetailPrint "IPAddress=$R0"
StrCpy $IPAddress $R0

${ConfigRead} "$TEMP\dhcpinfo.txt" "MACAddress=" $R0
DetailPrint "MACAddress=$R0"
StrCpy $MACAddress $R0

${ConfigRead} "$TEMP\dhcpinfo.txt" "DHCPServer=" $R0
DetailPrint "DHCPServerIP=$R0"
StrCpy $DHCPServerIP "$R0" 



notdhcp:

DetailPrint ""

FunctionEnd





Function FWCheck

DetailPrint ""
DetailPrint "                                                      Firewall"


;ExpandEnvStrings $0 %COMSPEC%
;nsExec::ExecToLog  '"$0" /C "cscript.exe"  /Nologo ;$TEMP\fwcheck.wsf > $TEMP\fwcheck.txt'

nsExec::ExecToLog  '"$TEMP\espscript.bat" "$TEMP\fwcheck.wsf" "$TEMP\fwcheck.txt"'


ifFileExists $TEMP\fwcheck.txt +1 nofw
${ConfigRead} "$TEMP\fwcheck.txt" "Name=" $R0
DetailPrint "[Firewall info from Windows Security Center] Name: $R0"

StrCpy $FW_INFO "$R0"


${ConfigRead} "$TEMP\fwcheck.txt" "Version=" $R0
DetailPrint "[Firewall info from Windows Security Center] Version: $R0"

StrCpy $FW_INFO "$FW_INFO $R0 "


nofw:

DetailPrint ""

FunctionEnd


;
; parsing XML output of MBSA v2 and saving in temp file for processing
;

Function MBSAv2XML

Pop $MBSAv2PatchFile

;;;;;;;;;;;

;; getting the update for MicrosoftUpdate to work with MBSA v2.0.1

DetailPrint "wget: downloading WindowsUpdateAgent20-x86.exe from CNS site "
DetailPrint "MBSA v2.0.1 will install this update if it needed"



nsExec::ExecToLog '"wget.exe" -q -T 10 -t 1 -O "$TEMP\WindowsUpdateAgent20-x86.exe" "$DOWNLOAD_URL/WindowsUpdateAgent20-x86.exe"'


Push "$TEMP\WindowsUpdateAgent20-x86.exe"
Call FileSizeNew
Pop $0
DetailPrint "File size: $0"
DetailPrint ""
; size of empty CAB file
;;IntCmp $0 8610 WSUScont



;;;;;;;;;;;




DetailPrint "wget: downloading wsusscn2.cab from CNS site"


nsExec::ExecToLog '"wget.exe" -q -T 10 -t 1 -O "$TEMP\wsusscn2.cab" "$DOWNLOAD_URL/wsusscn2.cab"'



StrCpy $WSUSSCAN ""
StrCpy $WSCATALOG ""

Push "$TEMP\wsusscn2.cab"
Call FileSizeNew
Pop $0
DetailPrint "File size: $0"
; size of empty CAB file
IntCmp $0 8610 WSUScont


StrCpy $WSUSSCAN "$TEMP\wsusscn2.cab"
StrCpy $WSCATALOG "/catalog"

DetailPrint "$TEMP\wsusscn2.cab was downloaded - catalog: $WSUSSCAN"

WSUScont:

;ExpandEnvStrings $0 %COMSPEC%
;nsExec::ExecToLog  '"$0" /C "$TEMP\mbsacli.exe" $WSUSSCAN" ;/xmlout > $TEMP\patches.xml'

DetailPrint "RUNNING THIS *NEW* ESP version *FIRST TIME* might take up to 5 min. Please wait."

;MessageBox MB_OK "Running this version of ESP first time might take longer than usual - up to 5 min. Please click OK and wait"

nsExec::ExecToLog  '"$TEMP\mbsa.bat" "$TEMP\mbsacli.exe" "/xmlout" "$TEMP\patches.xml"'

;nsExec::ExecToLog  '"$TEMP\mbsa.bat" "$TEMP\mbsacli.exe" ;"$WSCATALOG" "$WSUSSCAN" "/xmlout" "$TEMP\patches.xml"'


xml::LoadFile /NOUNLOAD "$TEMP\patches.xml" .r0
;MessageBox MB_OK "xml::LoadFile$\n$$0=$0"

xml::RootElement /NOUNLOAD .r0 .r1
;MessageBox MB_OK "xml::RootElement$\n$$0=$0$\n$$1=$1"

xml::NoChildren /NOUNLOAD .r0
StrCmp $0 "1" 0 loop1
StrCpy $FAIL_DETAIL_STR "MBSA v2 : Windows Update Agent probably missing, run WindowsUpdate"



loop1:

xml::FindNextElement /NOUNLOAD "UpdateData" .r0 .r1

StrCpy $MBSAv2data $0
StrCpy $ElemCode $1

xml::GetAttribute /NOUNLOAD "BulletinID" .r0 .r1
StrCpy $MBSAv2BID $0

xml::GetAttribute /NOUNLOAD "IsInstalled" .r0 .r1
StrCpy $MBSAv2PatchStatus $0

;MessageBox MB_OK "--- $\n$MBSAv2BID=$MBSAv2PatchStatus"

StrCmp $MBSAv2PatchStatus "false" +1 +2
StrCpy $MBSAv2PatchList "$MBSAv2PatchList$\n$MBSAv2BID"

StrCmp $ElemCode "-1" +1 loop1

DetailPrint ""
DetailPrint "$MBSAv2PatchList"
DetailPrint ""


;DetailPrint ""
;DetailPrint "$MBSAv2PatchList"
;DetailPrint ""

ClearErrors
FileOpen $1 $MBSAv2PatchFile w
IfErrors xmldone
FileWrite $1 "$MBSAv2PatchList"
xmldone:
FileClose $1

; to unload the XML plugin
xml::NodeHandle .r0


FunctionEnd



; get AV info - test function
; to use ConfigRead multiple times we have to use ConfigWrite
; to delete read entries
; ---------------------------
Function AntiVirusInfo

StrCpy $AllAVuptodate "yes"
StrCpy $NumAV 0
StrCpy $GlobalAVUptodateStatus "missing"

DetailPrint ""
DetailPrint "                     AntiVirusInfo"
DetailPrint ""

ExpandEnvStrings $0 %COMSPEC%
nsExec::ExecToLog  '"$TEMP\espscript.bat" "$TEMP\avcheck.wsf" "$TEMP\avcheck.tmp"'

DetailPrint ""

ifFileExists $TEMP\avcheck.tmp startavi +1
StrCpy $GlobalAVUptodateStatus "missing"
Goto endavi



startavi:

  ${ConfigRead} "$TEMP\avcheck.tmp" "Name=" $CurrAVName
  
  StrCmp $CurrAVName "" endavi +1

  StrCmp $LogCurrAVName "" +1 +3
  StrCpy $LogCurrAVName $CurrAVName
  Goto +2
  StrCpy $LogCurrAVName "$LogCurrAVName,$CurrAVName"

  StrCmp $CurrAVName "Windows Live OneCare" +1 +2
  StrCpy $LiveOneCare $CurrAVName

; counting AVs
  IntOp $NumAV $NumAV + 1
  ${ConfigWrite} "$TEMP\avcheck.tmp" "Name=" "" $R1
  DetailPrint "Name=$CurrAVName"

  ${ConfigRead} "$TEMP\avcheck.tmp" "Version=" $CurrAVVersion

  StrCmp $LogCurrAVVersion "" +1 +3
  StrCpy $LogCurrAVVersion $CurrAVVersion
  Goto +2
  StrCpy $LogCurrAVVersion "$LogCurrAVVersion,$CurrAVVersion"

  DetailPrint "Version=$CurrAVVersion"
  ${ConfigWrite} "$TEMP\avcheck.tmp" "Version=" "" $R1
 
  ${ConfigRead} "$TEMP\avcheck.tmp" "WSCstatus=" $CurrAVStatus

  StrCmp $CurrAVStatus "uptodate" +2 +1
  StrCpy $AllAVuptodate "no"

  StrCmp $LogCurrAVStatus "" +1 +3
  StrCpy $LogCurrAVStatus $CurrAVStatus
  Goto +2
  StrCpy $LogCurrAVStatus "$LogCurrAVStatus,$CurrAVStatus"


  StrCmp $LiveOneCare "Windows Live OneCare" +1 +2
  StrCpy $LiveOneCare "$LiveOneCare $CurrAVStatus"

  StrCmp $GlobalAVUptodateStatus "uptodate" +2 +1
  StrCpy $GlobalAVUptodateStatus $CurrAVStatus

  StrCpy $GlobalAVInfo "$GlobalAVInfo [$CurrAVName $CurrAVVersion is $CurrAVStatus]$\n"

  DetailPrint "WSCstatus=$CurrAVStatus"
  ${ConfigWrite} "$TEMP\avcheck.tmp" "WSCstatus=" "" $R1

Goto startavi

endavi:





DetailPrint ""


Call EICARCheck
Call AVServiceDetect

StrCpy $AVInfoPopUpMsg "Number of AntiViruses: $NumAV$\nGlobal AV Status: $GlobalAVUptodateStatus$\n$GlobalAVInfo EICAR test: $EICAR_AV_DETAIL$\nAV Service(s) detected: $AV_SERVICE"


StrCpy $AV_INFO "WSCname=$LogCurrAVName&WSCversion=$LogCurrAVVersion&WSCstatus=$LogCurrAVStatus&EICAR=$EICAR_AV_DETAIL&AV_SERVICE=$AV_SERVICE"

FunctionEnd




; AV EICAR file check
; -------------------

Function EICARCheck

StrCpy $AV_SLEEP_DELAY 10000
StrCpy $AV_SERVICE ""
StrCpy $EICAR_AV_DETAIL "pass"

MessageBox MB_OK "                                   AntiVirus Software Test$\nYou should see an *additional* AntiVirus Pop-Up message if AV is installed$\n and the Real-Time scan feature is turned on.  Please choose $\nto delete EICAR test file and/or close the AntiVirus pop-up windows."


ClearErrors
FileOpen $0 $EICAR_FILE w
IfErrors done
FileWrite $0 'X5O!'
FileWrite $0 'P%@AP[4\PZX54(P^)7CC)7}$'
FileWrite $0 'EICAR-STANDARD-ANTIVIRUS-TEST-FILE!'
FileWrite $0 '$'
FileWrite $0 'H'
FileWrite $0 '+H*'

FileClose $0
done:


ClearErrors
FileOpen $0 $EICAR_FILE r
IfErrors doneread
FileRead $0 $1
FileClose $0
doneread:


DetailPrint "AntiVirus check: waiting for $AV_SLEEP_DELAY miliseconds for AV to trigger on EICAR test"
sleep $AV_SLEEP_DELAY


IfFileExists $EICAR_FILE 0 end
  StrCpy $EICAR_AV_DETAIL "fail"



end:


FunctionEnd 



; AV service process detection
; ----------------------------

Function AVServiceDetect


nsExec::ExecToLog  '"$TEMP\espscript.bat" "$TEMP\listservices.js" "$TEMP\avservice.txt"'


  ifFileExists $TEMP\avservice.txt +1 end_avsrvcdetect

StrCpy $AV_SLEEP_DELAY 10000
StrCpy $AV_SERVICE ""

${ConfigRead} "$TEMP\avservice.txt" "AVG=" $R0
StrCmp $R0 "Running" +1 panda
StrCpy $AV_SERVICE "AVG:$R0"
StrCpy $AV_SLEEP_DELAY 20000 
DetailPrint "AntiVirus process: AVG $R0"

panda:
${ConfigRead} "$TEMP\avservice.txt" "Panda=" $R0
StrCmp $R0 "Running" +1 symantec
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICEPanda:$R0"
StrCpy $AV_SLEEP_DELAY 20000
DetailPrint "AntiVirus process: Panda $R0"

symantec:
${ConfigRead} "$TEMP\avservice.txt" "Symantec=" $R0
StrCmp $R0 "Running" +1 trendmicro
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICESymantec:$R0"
DetailPrint "AntiVirus process: Symantec $R0"

trendmicro:
${ConfigRead} "$TEMP\avservice.txt" "Trend Micro=" $R0
StrCmp $R0 "Running" +1 mcafee
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICETrenMicro:$R0"
StrCpy $AV_SLEEP_DELAY 20000
DetailPrint "AntiVirus process: Trend Micro $R0"

mcafee:
${ConfigRead} "$TEMP\avservice.txt" "McAfee=" $R0
StrCmp $R0 "Running" +1 fsecure
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICEMcAfee:$R0"
DetailPrint "AntiVirus process: McAfee $R0"

fsecure:
${ConfigRead} "$TEMP\avservice.txt" "F-Secure=" $R0
StrCmp $R0 "Running" +1 kav
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICEF-Secure:$R0"
StrCpy $AV_SLEEP_DELAY 20000
DetailPrint "AntiVirus process: F-Secure $R0"

kav:
${ConfigRead} "$TEMP\avservice.txt" "Kaspersky=" $R0
StrCmp $R0 "Running" +1 norton
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICEKaspersky:$R0"
StrCpy $AV_SLEEP_DELAY 20000
DetailPrint "AntiVirus process: Kaspersky $R0"

norton:
${ConfigRead} "$TEMP\avservice.txt" "Norton 200x=" $R0
StrCmp $R0 "Running" +1 norton7
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICENorton 200x:$R0"
StrCpy $AV_SLEEP_DELAY 10000
DetailPrint "AntiVirus process: Norton 200x $R0"

norton7:
${ConfigRead} "$TEMP\avservice.txt" "Norton 7.x=" $R0
StrCmp $R0 "Running" +1 end_avsrvcdetect
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICENorton 7.x:$R0"
StrCpy $AV_SLEEP_DELAY 10000
DetailPrint "AntiVirus process: Norton 7.x $R0"

end_avsrvcdetect:

FunctionEnd




Function AVCheck

DetailPrint "                                                      AntiVirus"
DetailPrint ""

  ExpandEnvStrings $0 %COMSPEC%
;  ExecWait  '"$0" /C "cscript.exe"  /Nologo $TEMP\avcheck.wsf > $TEMP\avcheck.txt'

nsExec::ExecToLog  '"$TEMP\espscript.bat" "$TEMP\avcheck.wsf" "$TEMP\avcheck.txt"'




; checking AV running as service
;  nsExec::ExecToLog  '"$0" /C "cscript.exe"  /Nologo ;$TEMP\listservices.js> $TEMP\avservice.txt'

; same .bat script - different parameters
nsExec::ExecToLog  '"$TEMP\espscript.bat" "$TEMP\listservices.js" "$TEMP\avservice.txt"'


  ifFileExists $TEMP\avservice.txt +1 av2

StrCpy $AV_SLEEP_DELAY 10000
StrCpy $AV_SERVICE ""

${ConfigRead} "$TEMP\avservice.txt" "AVG=" $R0
StrCmp $R0 "Running" +1 panda
StrCpy $AV_SERVICE "AVG:$R0"
StrCpy $AV_SLEEP_DELAY 20000 
DetailPrint "AntiVirus process: AVG $R0"

panda:
${ConfigRead} "$TEMP\avservice.txt" "Panda=" $R0
StrCmp $R0 "Running" +1 symantec
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICEPanda:$R0"
StrCpy $AV_SLEEP_DELAY 20000
DetailPrint "AntiVirus process: Panda $R0"

symantec:
${ConfigRead} "$TEMP\avservice.txt" "Symantec=" $R0
StrCmp $R0 "Running" +1 trendmicro
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICESymantec:$R0"
DetailPrint "AntiVirus process: Symantec $R0"

trendmicro:
${ConfigRead} "$TEMP\avservice.txt" "Trend Micro=" $R0
StrCmp $R0 "Running" +1 mcafee
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICETrenMicro:$R0"
StrCpy $AV_SLEEP_DELAY 20000
DetailPrint "AntiVirus process: Trend Micro $R0"

mcafee:
${ConfigRead} "$TEMP\avservice.txt" "McAfee=" $R0
StrCmp $R0 "Running" +1 fsecure
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICEMcAfee:$R0"
DetailPrint "AntiVirus process: McAfee $R0"

fsecure:
${ConfigRead} "$TEMP\avservice.txt" "F-Secure=" $R0
StrCmp $R0 "Running" +1 kav
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICEF-Secure:$R0"
StrCpy $AV_SLEEP_DELAY 20000
DetailPrint "AntiVirus process: F-Secure $R0"

kav:
${ConfigRead} "$TEMP\avservice.txt" "Kaspersky=" $R0
StrCmp $R0 "Running" +1 norton
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICEKaspersky:$R0"
StrCpy $AV_SLEEP_DELAY 20000
DetailPrint "AntiVirus process: Kaspersky $R0"

norton:
${ConfigRead} "$TEMP\avservice.txt" "Norton 200x=" $R0
StrCmp $R0 "Running" +1 norton7
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICENorton 200x:$R0"
StrCpy $AV_SLEEP_DELAY 10000
DetailPrint "AntiVirus process: Norton 200x $R0"

norton7:
${ConfigRead} "$TEMP\avservice.txt" "Norton 7.x=" $R0
StrCmp $R0 "Running" +1 av2
StrCmp $AV_SERVICE "" +2 +1
StrCpy $AV_SERVICE "$AV_SERVICE,"
StrCpy $AV_SERVICE "$AV_SERVICENorton 7.x:$R0"
StrCpy $AV_SLEEP_DELAY 10000
DetailPrint "AntiVirus process: Norton 7.x $R0"




av2:

;  nsExec::ExecToLog  '"$0" /C "cscript.exe"  /Nologo ;$TEMP\avcheck.wsf > $TEMP\avcheck.txt'

nsExec::ExecToLog  '"$TEMP\espscript.bat" "$TEMP\avcheck.wsf" "$TEMP\avcheck.txt"'


  ifFileExists $TEMP\avcheck.txt +1 noav



; reading/printing info about all AVs installed and their status
;DetailPrint ""
;ClearErrors
;FileOpen $0 $TEMP\avcheck.txt r
;IfErrors doneavcheckread

;avcheckread:
;FileRead $0 $1
;IfErrors doneavcheckread
;push $1
;Call TrimNewlines
;pop $1
;DetailPrint $1
;Goto avcheckread
;FileClose $0
;doneavcheckread:
;DetailPrint ""


  ${ConfigRead} "$TEMP\avcheck.txt" "Name=" $R0
  DetailPrint "[AntiVirus info from Windows Security Center] Name: $R0"
  StrCpy $AV_INFO "WSCname=$R0"	

  StrCmp $R0 "Windows Live OneCare" +1 +2
  StrCpy $LiveOneCare $R0
 


${ConfigRead} "$TEMP\avcheck.txt" "Version=" $R0
 DetailPrint "[AntiVirus info from Windows Security Center] Version: $R0"
 StrCpy $AV_INFO "$AV_INFO&WSCversion=$R0"

;${ConfigRead} "$TEMP\avcheck.txt" "LUstatus=" $R0
;  DetailPrint "[AntiVirus] LiveUpdate status : $R0"

${ConfigRead} "$TEMP\avcheck.txt" "WSCstatus=" $R0
  DetailPrint "[AntiVirus info from Windows Security Center] Up-to-date status: $R0"
StrCpy $AV_INFO "$AV_INFO&WSCstatus=$R0"

StrCmp $LiveOneCare "Windows Live OneCare" +1 +2
StrCpy $LiveOneCare "$LiveOneCare $R0"


StrCpy $AV_UPTODATE $R0 
StrCmp $R0 "" +1 +3
StrCpy $AV_DETAIL "missing"
Goto eicar
StrCpy $AV_DETAIL "installed"
Goto eicar

noav:
  StrCpy $AV_DETAIL "missing"

eicar:


MessageBox MB_OK "                                   AntiVirus Software Test$\nYou should see an *additional* AntiVirus Pop-Up message if AV is installed$\n and the Real-Time scan feature is turned on.  Please choose $\nto delete EICAR test file and/or close the AntiVirus pop-up windows."


ClearErrors
FileOpen $0 $EICAR_FILE w
IfErrors done
FileWrite $0 'X5O!'
FileWrite $0 'P%@AP[4\PZX54(P^)7CC)7}$'
FileWrite $0 'EICAR-STANDARD-ANTIVIRUS-TEST-FILE!'
FileWrite $0 '$'
FileWrite $0 'H'
FileWrite $0 '+H*'

FileClose $0
done:


ClearErrors
FileOpen $0 $EICAR_FILE r
IfErrors doneread
FileRead $0 $1
FileClose $0
doneread:


DetailPrint "AntiVirus check: waiting for $AV_SLEEP_DELAY miliseconds for AV to trigger on EICAR test"
sleep $AV_SLEEP_DELAY


; Workaround for Windows Live OneCare
; if Live OneCare is uptodate EICAR sets to pass

; by default it's set tp 'pass'
StrCpy $EICAR_AV_DETAIL "pass"

DetailPrint "[LiveOneCare status]: $LiveOneCare"
StrCmp $LiveOneCare "Windows Live OneCare uptodate" end +1 



IfFileExists $EICAR_FILE 0 end
  StrCpy $EICAR_AV_DETAIL "fail"



end:
DetailPrint "[AntiVirus summary from Windows Security Center] : $AV_DETAIL"
DetailPrint "EICAR AntiVirus check: $EICAR_AV_DETAIL"
DetailPrint ""
StrCpy $AV_INFO "$AV_INFO&EICAR=$EICAR_AV_DETAIL"

push $AV_UPTODATE
push $EICAR_AV_DETAIL
push $AV_DETAIL

FunctionEnd


; This function sets the config file based on installer name
; if installer has "_" in its name it will run in the ESP mode reading checker_cfg_nr.txt
; otherwise it'll use checker_cfg.txt

Function ChooseCfg

System::Call 'kernel32::GetModuleFileNameA(i 0, t .R0, i 1024) i r1'  
StrCpy $INSTALLER_NAME $R0

StrCpy $CHECKER_CFG "checker_cfg.txt"
StrLen $0 $INSTALLER_NAME

grmloop:

 IntCmp $0 0 grmend

 IntOp $0 $0 - 1

 StrCpy $1 $INSTALLER_NAME 1 $0

 StrCmp $1 "\" grmend +1
 StrCmp $1 "_" +1 grmloop


 StrCpy $CHECKER_CFG "checker_cfg_nr.txt"  

grmend:

FunctionEnd



Function FileSizeNew 
 
  Exch $0
  Push $1
  FileOpen $1 $0 "r"
  FileSeek $1 0 END $0
  FileClose $1
  Pop $1
  Exch $0
 
FunctionEnd


 ;
 ; Based on Yazno's function, http://yazno.tripod.com/powerpimpit/
 ; Updated by Joost Verburg
 ;
 ; Returns on top of stack
 ;
 ; Windows Version (95, 98, ME, NT x.x, 2000, XP, 2003)
 ; or
 ; '' (Unknown Windows Version)
 ;
 ; Usage:
 ;   Call GetWindowsVersion
 ;   Pop $R0
 ;   ; at this point $R0 is "NT 4.0" or whatnot
 
 Function GetWindowsVersion
 
   Push $R0
   Push $R1

; to combat Vista Compatibility feature - if this key present we think it's Vista
; this needs to be revisited to indentify Vista more presizely

Strcpy $VISTA_FLAG 'No'
ClearErrors
   ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion\AppCompatFlags" "ApphelpUIExe"
IfErrors lbl_osdetect 0
Strcpy $VISTA_FLAG 'Yes'


lbl_osdetect:

   ReadRegStr $R1 HKLM \
   "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion


   IfErrors lbl_unsupported lbl_winnt
 
   lbl_unsupported:
     StrCpy $R0 'Unsupported'
   Goto lbl_done

 
   lbl_winnt:

 
   StrCmp $R1 '6.0' lbl_winnt_vista
   StrCmp $R1 '5.0' lbl_winnt_2000
   StrCmp $R1 '5.1' lbl_winnt_XP
   StrCmp $R1 '5.2' lbl_winnt_2003 lbl_error
   
 
   lbl_winnt_2000:
     Strcpy $R0 '2000'
     StrCmp $VISTA_FLAG 'Yes' lbl_winnt_vista
   Goto lbl_done
 
   lbl_winnt_XP:
     Strcpy $R0 'XP'
     StrCmp $VISTA_FLAG 'Yes' lbl_winnt_vista
   Goto lbl_done
 
   lbl_winnt_2003:
     Strcpy $R0 '2003'
     StrCmp $VISTA_FLAG 'Yes' lbl_winnt_vista
   Goto lbl_done

   lbl_winnt_vista:
     Strcpy $R0 'Vista'
   Goto lbl_done
 
   lbl_error:
     Strcpy $R0 'Unknown[$R1]'
   lbl_done:
 
;   MessageBox MB_OK "{$R1} {$R0}"
   Pop $R1
   Exch $R0
 
 FunctionEnd

;Usage: 
;Push C:\temp1.txt 
;Push hello 
;Call FileSearch 
;Pop $0 #Number of times found throughout 
;Pop $1 #Found at all? yes/no 
;Pop $2 #Number of lines found in 
;
;StrCmp $1 yes 0 +2 
;MessageBox MB_OK "$\"hello$\" was found in the file $0 times on $2 lines." 

Function FileSearch

  Exch $0 ;search for
  Exch
  Exch $1 ;input file
  Exch
  Push $2
  Push $3
  Push $4
  Push $5
  Push $6
  Push $7
  Push $8
  Push $9
  Push $R0
    FileOpen $2 $1 r
  StrLen $4 $0
  StrCpy $5 0
  StrCpy $7 no
  StrCpy $8 0
  StrCpy $9 0
loop_main:
  FileRead $2 $3
  IfErrors done
 IntOp $R0 $R0 + $9
  StrCpy $9 0
  StrCpy $5 0
filter_top:
 IntOp $5 $5 - 1
  StrCpy $6 $3 $4 $5
  StrCmp $6 "" loop_main
  StrCmp $6 $0 0 filter_top
  StrCpy $3 $3 $5
  StrCpy $5 0
 StrCpy $7 yes
 StrCpy $9 1
 IntOp $8 $8 + 1
Goto filter_top
done:
  FileClose $2
  StrCpy $0 $8
  StrCpy $1 $7
  StrCpy $2 $R0
Pop $R0
Pop $9
Pop $8
Pop $7
Pop $6
Pop $5
Pop $4
Pop $3
Exch 2
Exch $2 ;output number of lines
Exch 2
Exch
Exch $1 ;output yes/no
Exch
Exch $0 ;output count found

FunctionEnd

; TrimNewlines
 ; input, top of stack  (e.g. whatever$\r$\n)
 ; output, top of stack (replaces, with e.g. whatever)
 ; modifies no other variables.

 Function TrimNewlines
   Exch $R0
   Push $R1
   Push $R2
   StrCpy $R1 0
 
 loop:
   IntOp $R1 $R1 - 1
   StrCpy $R2 $R0 1 $R1
   StrCmp $R2 "$\r" loop
   StrCmp $R2 "$\n" loop
   IntOp $R1 $R1 + 1
   IntCmp $R1 0 no_trim_needed
   StrCpy $R0 $R0 $R1
 
 no_trim_needed:
   Pop $R2
   Pop $R1
   Exch $R0
 FunctionEnd

; GetServicePack
; Author: Alessio Garbi (e-Project srl)  
;
; input:
;			none
; output:
;    	top of stack: last service pack major version
;    	top of stack-1: last service pack minor version
; note:
;			If no service pack installed returns major ver "0" and minor ver "0"
;			Function tested with Win 95, 98SE, NT4, 2000, XP, 2003 (lang ITA and ENG)
;			$R0, $R1 are NOT saved in stack so you have to preserve them outside this function!

Function GetServicePack

	ReadRegStr $R0 HKLM "System\CurrentControlSet\Control\Windows" "CSDVersion"
	IntOp $R1 $R0 % 256			;get minor version
	Push $R1
	IntOp $R0 $R0 / 256			;get major version
	Push $R0
		
FunctionEnd

; GetIEVersion
;
; Based on Yazno's function, http://yazno.tripod.com/powerpimpit/
; Returns on top of stack
; 1-6 (Installed IE Version)
; or
; '' (IE is not installed)
;
; Usage:
;   Call GetIEVersion
;   Pop $R0
;   ; at this point $R0 is "5" or whatnot

Function GetIEVersion
  Push $R0
  ClearErrors
  ReadRegStr $R0 HKLM "Software\Microsoft\Internet Explorer" "Version"
  IfErrors lbl_123 lbl_456

  lbl_456: ; ie 4+
    Strcpy $R0 $R0 1
  Goto lbl_done

  lbl_123: ; older ie version
    ClearErrors
    ReadRegStr $R0 HKLM "Software\Microsoft\Internet Explorer" "IVer"
    IfErrors lbl_error

      StrCpy $R0 $R0 3
        StrCmp $R0 '100' lbl_ie1
        StrCmp $R0 '101' lbl_ie2
        StrCmp $R0 '102' lbl_ie2
        StrCpy $R0 '3' ; default to ie3 if not 100, 101, or 102.
        Goto lbl_done
          lbl_ie1:
            StrCpy $R0 '1'
          Goto lbl_done
          lbl_ie2:
            StrCpy $R0 '2'
          Goto lbl_done
       lbl_error:
         StrCpy $R0 ''
   lbl_done:
   Exch $R0
FunctionEnd


;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_SecDummy ${LANG_ENGLISH} "A test section."

  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SecDummy} $(DESC_SecDummy)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END